<?php
/**
* @version $Id: mail.class.php 3062 2007-12-28 17:52:36Z Radek Suski $
* @package: Sigsiu Online Business Index 2
* ===================================================
* @author
* Name: Sigrid & Radek Suski, Sigsiu.NET
* Email: sobi@sigsiu.net
* Url: http://www.sigsiu.net
* ===================================================
* @copyright Copyright (C) 2007 Sigsiu.NET (http://www.sigsiu.net). All rights reserved.
* @license see http://www.gnu.org/licenses/lgpl.html GNU/LGPL.
* You can use, redistribute this file and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation.
*/
/*
 * no direct access
 */
defined( '_SOBI2_' )  || ( trigger_error("Restricted access", E_USER_ERROR) && exit() );
class sobi2Mail {
	/**
	 * function for send emails
	 *
	 * @param string $subject
	 * @param string $massage
	 * @param string $addresse
	 * @param boolean $forAdmin
	 * @param string $fromMail
	 * @param string $fromName
	 * @param integer $sobiId
	 */
	function send($subject, $massage, $addresse = null, $forAdmin = false, $fromMail = null, $fromName = null, $sobiId = null)
	{
		$config =& sobi2Config::getInstance();
		if(!$fromMail || !$fromName) {
			if ( $config->mailfrom && $config->fromname ) {
				$fromName = $config->fromname;
				$fromMail = $config->mailfrom;
			}
			else {
				$query = "SELECT name, email"
				. "\n FROM #__users"
				. "\n WHERE LOWER( usertype ) = 'superadministrator'"
				. "\n OR LOWER( usertype ) = 'super administrator'"
				;
				$config->database->setQuery( $query );
				$rows = $config->database->loadObjectList();
				$row2 			= $rows[0];
				$fromName 	= $row2->name;
				$fromMail 	= $row2->email;
			}
		}
		if( $forAdmin ) {
			$query = "SELECT email, name"
				. "\n FROM #__users"
				. "\n WHERE gid IN ({$config->mailAdmGid})"
				. "\n AND ( sendemail = 1 OR gid IN (18, 19, 20, 21, 23) )"
				;
			$config->database->setQuery( $query );
			$config->database->query();
			$adminRows = $config->database->loadObjectList();
			foreach( $adminRows as $adminRow) {
				mosMail($fromMail, $fromName, $adminRow->email, $config->makeSubject( $subject ), $massage);
			}
		}
		if($sobiId) {
			if($config->mailSoJ == 0) {
				$query = "SELECT `data_txt` FROM `#__sobi2_fields_data` WHERE `fieldid` = {$config->mailFieldId} AND `itemid` = {$sobiId}";
				$config->database->setQuery( $query );
				$addresse = $config->database->loadResult();
				$uname = null;
			}
			else {
				sobi2Config::import("sobi2.class");
				$sobi = new sobi2( $sobiId );
				$u = new mosUser($config->database);
				$u->load( $sobi->owner );
				$addresse = $u->email;
				$uname = $u->username;
			}
			if(!$addresse) {
				trigger_error("sobi2config::sendSobiMail(): Having no valid email address for the entry: {$sobiId}. Email from: {$config->mailSoJ}/{$uname}", E_USER_WARNING);
			}
		}
		if( $addresse ) {
			mosMail( $fromMail, $fromName, $addresse, $config->makeSubject( $subject ), $massage );
		}
		else {
			trigger_error("sobi2config::sendSobiMail(): No valid email address available", E_USER_WARNING );
		}
	}}
?>